Index: /branches/HivePerformance/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/Web.config
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/Web.config	(revision 9655)
+++ /branches/HivePerformance/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/Web.config	(revision 9656)
@@ -59,5 +59,5 @@
     <bindings>
       <wsHttpBinding>
-        <binding name="WSHttpBinding_IHiveService" messageEncoding="Text" receiveTimeout="00:15:00" sendTimeout="00:10:00" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647">
+        <binding name="WSHttpBinding_IHiveService" messageEncoding="Text" receiveTimeout="00:35:00" sendTimeout="00:35:00" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647">
           <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647" maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
           <security mode="Message">
@@ -68,5 +68,5 @@
       </wsHttpBinding>
       <netTcpBinding>
-        <binding name="NetTcpBinding_IHiveService" portSharingEnabled="true" receiveTimeout="00:15:00" sendTimeout="00:10:00" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647">
+        <binding name="NetTcpBinding_IHiveService" portSharingEnabled="true" receiveTimeout="00:35:00" sendTimeout="00:35:00" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647">
           <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647" maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
           <security mode="TransportWithMessageCredential">
Index: /branches/HivePerformance/sources/HeuristicLab.Services.Hive.Web/web_services.config
===================================================================
--- /branches/HivePerformance/sources/HeuristicLab.Services.Hive.Web/web_services.config	(revision 9655)
+++ /branches/HivePerformance/sources/HeuristicLab.Services.Hive.Web/web_services.config	(revision 9656)
@@ -29,8 +29,8 @@
   </connectionStrings>
   
-  <system.web>
+  <system.web>      
 	<customErrors mode="Off"/>
     <authentication mode="Forms" />
-    <compilation debug="true" targetFramework="4.0">
+    <compilation debug="true" targetFramework="4.0" batch="false">
       <assemblies>
         <add assembly="System.Web.DataVisualization, Version=4.0.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
@@ -55,6 +55,5 @@
       </controls>
     </pages>
-    <httpRuntime maxRequestLength="2147483647"/>
-	
+    <httpRuntime maxRequestLength="2147483647"/>		
   </system.web>
   
@@ -67,6 +66,6 @@
       <wsHttpBinding>
         <binding name="WSHttpBinding_IHiveService" 
-		  receiveTimeout="00:15:00"
-          sendTimeout="00:10:00" 
+		  receiveTimeout="00:35:00"
+          sendTimeout="00:35:00" 
 		  maxBufferPoolSize="2147483647" 
 		  maxReceivedMessageSize="2147483647">
@@ -78,4 +77,13 @@
         </binding>
       </wsHttpBinding>
+	  <netTcpBinding>
+        <binding name="NetTcpBinding_IHiveService" portSharingEnabled="true" receiveTimeout="00:35:00" sendTimeout="00:35:00" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647">
+          <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647" maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
+          <security mode="TransportWithMessageCredential">
+            <transport clientCredentialType="Certificate"/>
+            <message clientCredentialType="UserName"/>
+          </security>
+        </binding>
+      </netTcpBinding>
     </bindings>
     
@@ -105,8 +113,10 @@
     </behaviors>
 
-    <services>
+     <services>
       <service behaviorConfiguration="ServiceBehaviour_IHiveService" name="HeuristicLab.Services.Hive.HiveService">
-        <endpoint address="mex" binding="mexHttpBinding" bindingConfiguration="" name="MexEndpoint" contract="IMetadataExchange" />
-        <endpoint binding="wsHttpBinding" bindingConfiguration="WSHttpBinding_IHiveService" name="WSHttpBinding_IHiveService" contract="HeuristicLab.Services.Hive.ServiceContracts.IHiveService" />
+        <endpoint address="mexhttp" binding="mexHttpBinding" bindingConfiguration="" name="MexHttpEndpoint" contract="IMetadataExchange"/>
+        <endpoint address="mex" binding="mexTcpBinding" bindingConfiguration="" name="MexTcpEndpoint" contract="IMetadataExchange"/>
+        <endpoint address="" binding="wsHttpBinding" bindingConfiguration="WSHttpBinding_IHiveService" name="WSHttpBinding_IHiveService" contract="HeuristicLab.Services.Hive.ServiceContracts.IHiveService"/>
+        <endpoint address="net.tcp://services.heuristiclab.com/Hive-3.3/HiveService.svc" binding="netTcpBinding"  bindingConfiguration="NetTcpBinding_IHiveService" name="NetBinding_IHiveService" contract="HeuristicLab.Services.Hive.ServiceContracts.IHiveService"/>
       </service>
     </services>