Index: branches/HeuristicLab.Problems.GPDL/HeuristicLab.Problems.GPDL.Views/3.4/Resources/symbreg HEAL.txt
===================================================================
--- branches/HeuristicLab.Problems.GPDL/HeuristicLab.Problems.GPDL.Views/3.4/Resources/symbreg HEAL.txt	(revision 9674)
+++ branches/HeuristicLab.Problems.GPDL/HeuristicLab.Problems.GPDL.Views/3.4/Resources/symbreg HEAL.txt	(revision 9696)
@@ -2,6 +2,6 @@
 
 CODE <<
-  double[,] inputValues;
-  double[] targetValues;
+  double[,] x;
+  double[] y;
   string[] variableNames;
   Dictionary<string,int> nameToCol;
@@ -15,5 +15,5 @@
       }
     }
-    return data[row, nameToCol[varName]];
+    return x[row, nameToCol[varName]];
   }
 
@@ -24,25 +24,23 @@
      else return 0.0;
   }
-  
-
-  void LoadData(string fileName, out double[,] inputValues, out string[] variableNames, out double[] target) {
-    var prov = new HeuristicLab.Problems.Instances.DataAnalysis.RegressionRealWorldInstanceProvider();
-    var dd = prov.GetDataDescriptors().OfType<HeuristicLab.Problems.Instances.DataAnalysis.Housing>().Single();
-    var problemData = prov.LoadData(dd);    
-    
-    inputValues = new double[problemData.TrainingIndices.Count(), problemData.AllowedInputVariables.Count()];
-    foreach(var r in problemData.TrainingIndices) {
-       int i=0;
-       foreach(var v in problemData.AllowedInputVariables) {
-          inputValues[r, i++] = problemData.Dataset.GetDoubleValue(v, r);
-       }
-    }
-    variableNames = problemData.AllowedInputVariables.ToArray();
-    target = problemData.Dataset.GetDoubleValues(problemData.TargetVariable, problemData.TrainingIndices).ToArray();
-  }
 >>
 
 INIT <<
-  LoadData("filename.csv", out inputValues, out variableNames, out targetValues);
+  // generate 500 case of poly-10 benchmark function
+  int n = 500;
+  variableNames = new string[] {"x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10" };
+  var rand = new System.Random();
+  x = new double[n, 10];
+  y = new double[n];
+  for(int row = 0; row < 500; row++) {
+    for(int col = 0; col < 10; col++) {
+      x[row, col] = rand.NextDouble() * 2.0 - 1.0;
+    }
+    y[row] = x[row, 0] * x[row, 1] +
+             x[row, 2] * x[row, 3] +
+             x[row, 4] * x[row, 5] +
+             x[row, 0] * x[row, 6] + x[row, 8] +
+             x[row, 2] * x[row, 5] + x[row, 9];
+  }
 >>
 
@@ -75,5 +73,5 @@
     | Division<<row, out val>>
     | Multiplication<<row, out val>>                       
-    | Var<<out varName, out w>>                            SEM << val = w * GetValue(inputValues, varName, row); >>
+    | Var<<out varName, out w>>                            SEM << val = w * GetValue(x, varName, row); >>
     | Const<<out val>>
   .
@@ -94,5 +92,5 @@
 MAXIMIZE                                                   /* could also use the keyword MINIMIZE here */
   << 
-    var rows = System.Linq.Enumerable.Range(0, inputValues.GetLength(0));
+    var rows = System.Linq.Enumerable.Range(0, x.GetLength(0));
     var predicted = rows.Select(r => {
       double result;
@@ -100,5 +98,5 @@
       return result;
     });
-    return RSquared(predicted, targetValues);
+    return RSquared(predicted, y);
   >>
 END SymbReg.
Index: branches/HeuristicLab.Problems.GPDL/HeuristicLab.Problems.GPDL.Views/3.4/Resources/symbreg Koza.txt
===================================================================
--- branches/HeuristicLab.Problems.GPDL/HeuristicLab.Problems.GPDL.Views/3.4/Resources/symbreg Koza.txt	(revision 9674)
+++ branches/HeuristicLab.Problems.GPDL/HeuristicLab.Problems.GPDL.Views/3.4/Resources/symbreg Koza.txt	(revision 9696)
@@ -1,6 +1,6 @@
 PROBLEM SymbRegKoza
 CODE <<
-  double[,] inputValues;
-  double[] targetValues;
+  double[,] x;
+  double[] y;
   string[] variableNames;
   Dictionary<string,int> nameToCol;
@@ -14,5 +14,5 @@
       }
     }
-    return data[row, nameToCol[varName]];
+    return x[row, nameToCol[varName]];
   }
 
@@ -23,25 +23,23 @@
      else return 0.0;
   }
-  
-
-  void LoadData(string fileName, out double[,] inputValues, out string[] variableNames, out double[] target) {
-    var prov = new HeuristicLab.Problems.Instances.DataAnalysis.RegressionRealWorldInstanceProvider();
-    var dd = prov.GetDataDescriptors().OfType<HeuristicLab.Problems.Instances.DataAnalysis.Housing>().Single();
-    var problemData = prov.LoadData(dd);    
-    
-    inputValues = new double[problemData.TrainingIndices.Count(), problemData.AllowedInputVariables.Count()];
-    foreach(var r in problemData.TrainingIndices) {
-       int i=0;
-       foreach(var v in problemData.AllowedInputVariables) {
-          inputValues[r, i++] = problemData.Dataset.GetDoubleValue(v, r);
-       }
-    }
-    variableNames = problemData.AllowedInputVariables.ToArray();
-    target = problemData.Dataset.GetDoubleValues(problemData.TargetVariable, problemData.TrainingIndices).ToArray();
-  }
 >>
 
 INIT <<
-  LoadData("filename.csv", out inputValues, out variableNames, out targetValues);
+  // generate 500 case of poly-10 benchmark function
+  int n = 500;
+  variableNames = new string[] {"x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10" };
+  var rand = new System.Random();
+  x = new double[n, 10];
+  y = new double[n];
+  for(int row = 0; row < 500; row++) {
+    for(int col = 0; col < 10; col++) {
+      x[row, col] = rand.NextDouble() * 2.0 - 1.0;
+    }
+    y[row] = x[row, 0] * x[row, 1] +
+             x[row, 2] * x[row, 3] +
+             x[row, 4] * x[row, 5] +
+             x[row, 0] * x[row, 6] + x[row, 8] +
+             x[row, 2] * x[row, 5] + x[row, 9];
+  }
 >>
 
@@ -74,5 +72,5 @@
     | Division<<row, out val>>
     | Multiplication<<row, out val>>
-    | Var<<out varName>>                                   SEM << val = GetValue(inputValues, varName, row); >>
+    | Var<<out varName>>                                   SEM << val = GetValue(x, varName, row); >>
     | ERC<<out val>>
   .
@@ -93,5 +91,5 @@
 MAXIMIZE                                                   /* could also use the keyword MINIMIZE here */
   << 
-    var rows = System.Linq.Enumerable.Range(0, inputValues.GetLength(0));
+    var rows = System.Linq.Enumerable.Range(0, x.GetLength(0));
     var predicted = rows.Select(r => {
       double result;
@@ -99,5 +97,5 @@
       return result;
     });
-    return RSquared(predicted, targetValues);
+    return RSquared(predicted, y);
   >>
 END SymbRegKoza.